module Sire
  class ImmutableDelegator < BasicObject
    def initialize(obj)
      @obj = obj
    end

    def method_missing(*args, &b)
      return super unless obj.respond_to?(args.first)
      res = obj.send(*args, &b)
      res.class == obj.class ? create_new(res) : res
    end

    private

    attr_reader :obj

    def create_new(res)
      self.class.new(res)
    end

    def respond_to_missing?(meth, privates = false)
      obj.respond_to?(meth, privates) || super
    end
  end
end
